=== debian/changelog ===
fibocom-pc-services (0~git202312251049.1eb588a-1~ubuntu22.04.1) jammy; urgency=medium

  * Initial release

 -- Kai-Chuan Hsieh <kaichuan.hsieh@canonical.com>  Fri, 15 Dec 2023 14:24:10 +0800
