=== debian/control ===
Source: fibocom-pc-services
Section: net
Priority: optional
Maintainer: Commercial Engineers <commercial-engineering@canonical.com>
Build-Depends:
 debhelper-compat (= 13),
 dh-modaliases,
 cmake,
 build-essential,
 pkg-config,
 libglib2.0-dev,
 libxml2-dev,
 libudev-dev,
 libmbim-glib-dev,
 libdbus-1-dev,
 libmm-glib-dev,
 udev,
Standards-Version: 4.6.0
Homepage: https://github.com/fibocom-pc/linux_apps_opensource
Vcs-Browser: https://github.com/fibocom-pc/linux_apps_opensource
Vcs-Git: https://github.com/fibocom-pc/linux_apps_opensource.git
Rules-Requires-Root: no

Package: fibocom-helper-service
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, modemmanager
Description: DBus API provider for Flash/Ma/Config service
 The package provides DBus API for Flash/Ma/Config service to communicate to
 the modem.

Package: fibocom-config-service
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fibocom-helper-service
XB-Modaliases: ${modaliases}
Description: OEM configuration functions for Fibocom modem
 The service provides OEM configurations functions.

Package: fibocom-ma-service
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fibocom-helper-service
XB-Modaliases: ${modaliases}
Description: Provide fccunlock function for Fibocom modem
 The service provides fccunlock function for fibocom modem.

Package: fibocom-flash-service
Architecture: any
Recommends: fibocom-firmware, fastboot
Depends: ${shlibs:Depends}, ${misc:Depends}, fibocom-helper-service
XB-Modaliases: ${modaliases}
Description: Provide firmware flash function for Fibocom modem
 The service provides firmware flash function for fibocom modem.
