=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --with modaliases

current_dir=$(shell pwd)
# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=. --builddirectory=build -- \
	    --install-prefix="$(current_dir)/debian/tmp"

override_dh_auto_build:
	cmake --build build

override_dh_auto_install:
	cmake --install build

override_dh_installsystemd:
	dh_installsystemd -pfibocom-helper-service --name=fibo_helper fibo_helper.service
	dh_installsystemd -pfibocom-helper-service --name=fibo_helper_mbim fibo_helper_mbim.service
	dh_installsystemd -pfibocom-flash-service --name=fibo_flash fibo_flash.service
	dh_installsystemd -pfibocom-config-service --name=fibo_config fibo_config.service

override_dh_auto_clean:
	dh_auto_clean -- \
	    rm -rf debian/tmp
	    rm -rf build/
