=== debian/changelog ===
fibocom-pc-services (0~git202312251049.1eb588a-1~ubuntu22.04.10) jammy; urgency=medium

  * Initial release

 -- Kai-Chuan Hsieh <kaichuan.hsieh@canonical.com>  Wed, 03 Sep 2025 14:29:50 +0800
