=== debian/rules ===
--- 
+++ 
@@ -35,6 +35,11 @@
 	dh_installsystemd -pfibocom-helper-service --name=fibo_helper_mbim fibo_helper_mbim.service
 	dh_installsystemd -pfibocom-flash-service --name=fibo_flash fibo_flash.service
 	dh_installsystemd -pfibocom-config-service --name=fibo_config fibo_config.service
+	dh_installsystemd -pfibocom-ma-service --name=fibo_ma --no-start fibo_ma.service
+
+override_dh_installdeb:
+	dh_apparmor --profile-name=opt.fibocom.fibo_ma_service.fibo_ma -pfibocom-ma-service
+	dh_installdeb
 
 override_dh_auto_clean:
 	dh_auto_clean -- \
