## fibocom-pc-services 0~git202508291421.319e058-1~ubuntu22.04.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,7 @@
 # minor = Small design change specific to any operation.
 # macro = small change or bug fix
 
-project(fibocom_linux VERSION 1.0.8)
+project(fibocom_linux VERSION 1.0.12)
 
 add_subdirectory (application)
