=== application/fibo_flash_service/CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,7 @@
 
 set(FLASH_MAJOR_VERSION 1)
 set(FLASH_MINOR_VERSION 0)
-set(FLASH_PATCH_VERSION 8)
+set(FLASH_PATCH_VERSION 9)
 
 set(FLASH_VERSION_STRING ${FLASH_MAJOR_VERSION}.${FLASH_MINOR_VERSION}.${FLASH_PATCH_VERSION})
