=== application/fibo_helper_service/CMakeLists.txt ===
--- 
+++ 
@@ -39,7 +39,7 @@
 
 set(HELPER_MAJOR_VERSION 1)
 set(HELPER_MINOR_VERSION 0)
-set(HELPER_PATCH_VERSION 8)
+set(HELPER_PATCH_VERSION 9)
 
 set(HELPER_VERSION_STRING ${HELPER_MAJOR_VERSION}.${HELPER_MINOR_VERSION}.${HELPER_PATCH_VERSION})
 configure_file("${CMAKE_CURRENT_SOURCE_DIR}/version.h.in"
