=== debian/changelog ===
fibocom-pc-services (0~git202508291421.319e058-1~ubuntu22.04.1) jammy; urgency=medium

  * Initial release

 -- Kai-Chuan Hsieh <kaichuan.hsieh@canonical.com>  Thu, 04 Sep 2025 14:21:21 +0800
