=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-modaliases,
+ dh-apparmor,
  cmake,
  build-essential,
  pkg-config,
@@ -21,9 +22,24 @@
 Vcs-Git: https://github.com/fibocom-pc/linux_apps_opensource.git
 Rules-Requires-Root: no
 
+Package: fibocom-pc-services
+Architecture: any
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends},
+ fibocom-config-service,
+ fibocom-flash-service,
+ fibocom-ma-service
+XB-Modaliases: ${modaliases}
+Description: Service packages for Fibocom Wireless WWAN modules
+ This metapackage installs all services for Fibocom Wireless WWAN modules.
+
 Package: fibocom-helper-service
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, modemmanager
+Provides: oem-fix-wwan-cnl-test-quick-suspend-resume
+Conflicts: oem-fix-wwan-cnl-test-quick-suspend-resume
+Replaces: oem-fix-wwan-cnl-test-quick-suspend-resume
 Description: DBus API provider for Flash/Ma/Config service
  The package provides DBus API for Flash/Ma/Config service to communicate to
  the modem.
@@ -31,14 +47,12 @@
 Package: fibocom-config-service
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, fibocom-helper-service
-XB-Modaliases: ${modaliases}
 Description: OEM configuration functions for Fibocom modem
  The service provides OEM configurations functions.
 
 Package: fibocom-ma-service
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, fibocom-helper-service
-XB-Modaliases: ${modaliases}
 Description: Provide fccunlock function for Fibocom modem
  The service provides fccunlock function for fibocom modem.
 
@@ -46,6 +60,5 @@
 Architecture: any
 Recommends: fibocom-firmware, fastboot
 Depends: ${shlibs:Depends}, ${misc:Depends}, fibocom-helper-service
-XB-Modaliases: ${modaliases}
 Description: Provide firmware flash function for Fibocom modem
  The service provides firmware flash function for fibocom modem.
